/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __CONFIGURE_CONTROLS_STATE_H__
#define __CONFIGURE_CONTROLS_STATE_H__

typedef struct ConfigureControlsState ConfigureControlsState;

#include "convergence/GamepadDetailView.h"
#include "convergence/GameSession.h"
#include "convergence/InputController.h"
#include "glbitmapfont/GLBitmapFont.h"
#include "statecontroller/State.h"

#define ConfigureControlsState_structContents \
	State_structContents \
	\
	GameSession * gameSession; \
	InputController * inputController; \
	GLBitmapFont * font; \
	size_t gamepadViewCount; \
	GamepadDetailView ** gamepadViews; \
	bool backgrounded; \
	int selectedControl; \
	char lastBindingMessage[128];

struct ConfigureControlsState {
	ConfigureControlsState_structContents
};

ConfigureControlsState * ConfigureControlsState_create(GameSession * gameSession);
void ConfigureControlsState_init(compat_type(ConfigureControlsState *) selfPtr, GameSession * gameSession);
void ConfigureControlsState_dispose(compat_type(ConfigureControlsState *) selfPtr);

void ConfigureControlsState_activate(compat_type(ConfigureControlsState *) selfPtr);
void ConfigureControlsState_deactivate(compat_type(ConfigureControlsState *) selfPtr);
void ConfigureControlsState_draw(compat_type(ConfigureControlsState *) selfPtr);

#endif
