/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __DUNGEON_KEY_VIEW_H__
#define __DUNGEON_KEY_VIEW_H__

typedef struct DungeonKeyView DungeonKeyView;

#include "convergence/GameObjectView.h"
#include "convergence/SwordSwingModel.h"
#include "glgraphics/GLIncludes.h"
#include "gltexture/GLTexture.h"
#include "resourcemanager/ResourceManager.h"

#define DungeonKeyView_structContents \
	GameObjectView_structContents \
	\
	ResourceManager * resourceManager; \
	GLuint vboID; \
	GLuint eboID; \
	GLTexture * texture;

struct DungeonKeyView {
	DungeonKeyView_structContents
};

DungeonKeyView * DungeonKeyView_create(compat_type(DungeonKeyModel *) modelPtr, ResourceManager * resourceManager);
void DungeonKeyView_init(compat_type(DungeonKeyView *) selfPtr, compat_type(DungeonKeyModel *) modelPtr, ResourceManager * resourceManager);
void DungeonKeyView_dispose(compat_type(DungeonKeyView *) selfPtr);

void DungeonKeyView_draw(compat_type(DungeonKeyView *) selfPtr, Matrix modelviewMatrix, double deltaTime);

#endif
