/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __GAMEPAD_AXIS_VIRTUAL_BUTTON_H__
#define __GAMEPAD_AXIS_VIRTUAL_BUTTON_H__

typedef struct GamepadAxisVirtualButton GamepadAxisVirtualButton;

// eventData -> struct Gamepad_buttonEvent * (HACK: buttonID is axisID)
#define GAMEPAD_AXIS_VIRTUAL_BUTTON_EVENT_DOWN "GAMEPAD_AXIS_VIRTUAL_BUTTON_EVENT_DOWN"
#define GAMEPAD_AXIS_VIRTUAL_BUTTON_EVENT_UP "GAMEPAD_AXIS_VIRTUAL_BUTTON_EVENT_UP"

#include "gamepad/Gamepad.h"
#include "stemobject/StemObject.h"
#include "utilities/Atom.h"
#include "utilities/EventDispatcher.h"

#define GamepadAxisVirtualButton_structContents \
	StemObject_structContents \
	\
	struct Gamepad_device * device; \
	unsigned int axisID; \
	Atom actionID; \
	int direction; \
	float triggerThreshold; \
	float releaseThreshold; \
	EventDispatcher * eventDispatcher; \
	int triggered; \
	\
	void (* update)(compat_type(GamepadAxisVirtualButton *) self, float value);

struct GamepadAxisVirtualButton {
	GamepadAxisVirtualButton_structContents
};

GamepadAxisVirtualButton * GamepadAxisVirtualButton_create(struct Gamepad_device * device, unsigned int axisID, Atom actionID, int direction, float triggerThreshold, float releaseThreshold);
void GamepadAxisVirtualButton_init(compat_type(GamepadAxisVirtualButton *) selfPtr, struct Gamepad_device * device, unsigned int axisID, Atom actionID, int direction, float triggerThreshold, float releaseThreshold);
void GamepadAxisVirtualButton_dispose(compat_type(GamepadAxisVirtualButton *) selfPtr);
void GamepadAxisVirtualButton_update(compat_type(GamepadAxisVirtualButton *) selfPtr, float value);

#endif
