/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __MOVING_ENTITY_VIEW_H__
#define __MOVING_ENTITY_VIEW_H__

typedef struct MovingEntityView MovingEntityView;

#include "convergence/GameObjectView.h"
#include "convergence/MovingEntityModel.h"
#include "glgraphics/GLIncludes.h"
#include <stdint.h>

#define MovingEntityView_structContents \
	GameObjectView_structContents \
	\
	GLuint vboID; \
	GLuint eboID; \
	uint32_t innerColor; \
	uint32_t outerColor;

struct MovingEntityView {
	MovingEntityView_structContents
};

MovingEntityView * MovingEntityView_create(compat_type(MovingEntityModel *) modelPtr);
void MovingEntityView_init(compat_type(MovingEntityView *) selfPtr, compat_type(MovingEntityModel *) modelPtr);
void MovingEntityView_dispose(compat_type(MovingEntityView *) selfPtr);

void MovingEntityView_draw(compat_type(MovingEntityView *) selfPtr, Matrix modelviewMatrix, double deltaTime);

#endif
