/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __PLAYER_SPY_MODEL_H__
#define __PLAYER_SPY_MODEL_H__

typedef struct PlayerSpyModel PlayerSpyModel;

#include "convergence/PlayerModel.h"

#define PlayerSpyModel_structContents \
	PlayerModel_structContents \
	\
	int attackCooldown; \
	Direction swordSwingFacing; \
	bool stealth; \
	int stealthCooldown; \
	\
	void (* enterStealth)(compat_type(PlayerSpyModel *) self); \
	void (* exitStealth)(compat_type(PlayerSpyModel *) self);

struct PlayerSpyModel {
	PlayerSpyModel_structContents
};

PlayerSpyModel * PlayerSpyModel_create(DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerSpyModel_init(compat_type(PlayerSpyModel *) selfPtr, DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerSpyModel_initCopy(compat_type(PlayerSpyModel *) selfPtr, compat_type(PlayerSpyModel *) originalPtr);
void PlayerSpyModel_dispose(compat_type(PlayerSpyModel *) selfPtr);

compat_type(PlayerSpyModel *) PlayerSpyModel_copy(compat_type(PlayerSpyModel *) selfPtr);
void PlayerSpyModel_update(compat_type(PlayerSpyModel *) selfPtr);
bool PlayerSpyModel_atRest(compat_type(PlayerSpyModel *) selfPtr);
void PlayerSpyModel_startAttack(compat_type(PlayerSpyModel *) selfPtr);
void PlayerSpyModel_startSpecialAction(compat_type(PlayerSpyModel *) selfPtr);
void PlayerSpyModel_spotted(compat_type(PlayerSpyModel *) selfPtr, compat_type(EnemyModel *) enemy);
void PlayerSpyModel_takeDamage(compat_type(PlayerSpyModel *) selfPtr, int amount, Direction fromDirection);
void PlayerSpyModel_enterStealth(compat_type(PlayerSpyModel *) selfPtr);
void PlayerSpyModel_exitStealth(compat_type(PlayerSpyModel *) selfPtr);

#endif
